﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

//Add MySql Library
using MySql.Data.MySqlClient;

namespace MySqlTest
{
    public partial class TopMenu : Form
    {

        public SSH_Tunnel SessionTunnel;
        public uint SessionPortNumber = 0;
        public MySqlConnectionStringBuilder ConnectionString = null;

        private MySqlConnection DBConnection = null;

        public TopMenu()
        {
            InitializeComponent();
            SessionTunnel = new SSH_Tunnel(this);

        }

        private void connectDatabaseToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!SessionTunnel.IsOpen())
            {

                if (!SessionTunnel.OpenTunnel())
                {
                    MessageBox.Show("Could not open secure tunnel to database server.\nNo data can be shown.", "SSH Open Fail", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    //Close the form prematurely
                    this.BeginInvoke(new MethodInvoker(Close));
                    return;
                }
                else
                {

                    //Parent session and port now populated in OpenTunnel()
                }

            }

            try
            {
                DBConnection = new MySqlConnection(ConnectionString.ConnectionString);
                DBConnection.Open();
                MessageBox.Show("DB Connection OPEN");
               
            }
            catch (Exception ex)
            {
                MessageBox.Show("Could not create a connection to the database. exception is:-\n\n" + ex.Message, "DB Connection FAIL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                
                return;
            }


        }

        private void TopMenu_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (DBConnection.State==System.Data.ConnectionState.Open)
            {
                DBConnection.Close();
                DBConnection.Dispose();
            }

            

            //Close off the session SSH tunnel
            if (SessionTunnel.IsOpen())
            {
                SessionTunnel.CloseTunnel();
            }

        }
    }
}
